

<template lang="pug">
    .voting-slider-container
        h6 Select voting power:
        .voting-slider
            VueSlider(v-model="power" :disabled="inProgress")
            button(@click="vote()" :disabled="inProgress") Vote

</template>

<script lang="ts">

    import Vue from "vue";
    import VueSlider from 'vue-slider-component'
    import VotingService from "../../services/VotingService";
    import { AxiosResponse } from "axios";

    import 'vue-slider-component/theme/default.css'

    export default Vue.component('VotingSlider', {
        components: {
            VueSlider
        },
        props: {
            permlink: {
                type: String,
                required: true
            },
            author: {
                type: String,
                required: true
            }
        },
        data() {
            return {
                power: 100,
                inProgress: false
            }
        },
        computed: {
            token() {
                return this.$store.state.sso.token;
            }
        },
        methods: {
            vote() {
                this.inProgress = true;
                VotingService.vote(this.author, this.permlink, this.power * 100, this.token)
                    .then( (result: AxiosResponse) => {
                        this.inProgress = false;
                        this.success()
                    } )
                    .catch((error: Error) => {
                        this.inProgress = false;
                        console.error(error);
                    })
            },
            success() {
                this.$emit('success');
            }
        }
    })

</script>

<style scoped>

    .v-popover {
        display: inline;
    }

    .voting-slider-container {
        background: white;
        border-radius: 5px;
        border: 1px solid #ccc;
        padding: 15px;
    }

    .voting-slider {
        display: inline;
    }
</style>
